module Insite
  METHOD_MAP = {Watir::Rect=>[:rect],
   Watir::HTMLElement=>
    [:var,
     :i,
     :abbr,
     :summary,
     :cite,
     :code,
     :address,
     :article,
     :aside,
     :bdi,
     :bdo,
     :dfn,
     :dt,
     :em,
     :figcaption,
     :figure,
     :footer,
     :kbd,
     :header,
     :mark,
     :noscript,
     :main,
     :nav,
     :dd,
     :rb,
     :rp,
     :rtc,
     :s,
     :rt,
     :small,
     :samp,
     :sub,
     :section,
     :strong,
     :sup,
     :element,
     :u,
     :b,
     :ruby,
     :wbr],
   Watir::Anchor=>[:a, :link],
   Watir::HTMLElementCollection=>
    [:headers,
     :is,
     :vars,
     :elements,
     :abbrs,
     :addresses,
     :articles,
     :asides,
     :bs,
     :bdis,
     :bdos,
     :cites,
     :codes,
     :dds,
     :dfns,
     :dts,
     :ems,
     :figures,
     :figcaptions,
     :footers,
     :mains,
     :marks,
     :kbds,
     :noscripts,
     :navs,
     :rps,
     :rubies,
     :rbs,
     :ss,
     :rtcs,
     :smalls,
     :samps,
     :rts,
     :sections,
     :subs,
     :summaries,
     :sups,
     :strongs,
     :us,
     :wbrs],
  Watir::TimeCollection=>[:times],
  Watir::Circle=>[:circle],
  Watir::CircleCollection=>[:circles],
  Watir::Defs=>[:defs],
  Watir::DefsCollection=>[:defss],
  Watir::Desc=>[:desc],
  Watir::DescCollection=>[:descs],
  Watir::Ellipse=>[:ellipse],
  Watir::EllipseCollection=>[:ellipses],
  Watir::ForeignObject=>[:foreign_object],
  Watir::ForeignObjectCollection=>[:foreign_objects],
  Watir::GCollection=>[:gs],
  Watir::Button=>[:button],
  Watir::LinearGradient=>[:linear_gradient],
  Watir::LinearGradientCollection=>[:linear_gradients],
  Watir::Marker=>[:marker],
  Watir::MarkerCollection=>[:markers],
  Watir::MetadataCollection=>[:metadatas],
  Watir::PatternCollection=>[:patterns],
  Watir::Polygon=>[:polygon],
  Watir::Pre=>[:pre],
  Watir::PolygonCollection=>[:polygons],
  Watir::Polyline=>[:polyline],
  Watir::AreaCollection=>[:areas],
  Watir::PolylineCollection=>[:polylines],
  Watir::Script=>[:script],
  Watir::RadialGradient=>[:radial_gradient],
  Watir::RadialGradientCollection=>[:radial_gradients],
  Watir::RectCollection=>[:rects],
  Watir::SVG=>[:svg],
  Watir::SVGCollection=>[:svgs],
  Watir::StopCollection=>[:stops],
  Watir::SwitchCollection=>[:switches],
  Watir::Body=>[:body],
  Watir::LI=>[:li],
  Watir::TextPathCollection=>[:text_paths],
  Watir::Metadata=>[:metadata],
  Watir::TSpan=>[:tspan],
  Watir::TextPath=>[:text_path],
  Watir::UseCollection=>[:uses],
  Watir::View=>[:view],
  Watir::ViewCollection=>[:views],
  Watir::TSpanCollection=>[:tspans],
  Watir::DateField=>[:date_field],
  Watir::CheckBox=>[:checkbox],
  Watir::CheckBoxCollection=>[:checkboxes],
  Watir::Style=>[:style],
  Watir::DateTimeField=>[:date_time_field],
  Watir::DateTimeFieldCollection=>[:date_time_fields],
  Watir::DateFieldCollection=>[:date_fields],
  Watir::FileField=>[:file_field],
  Watir::FileFieldCollection=>[:file_fields],
  Watir::Font=>[:font],
  Watir::FontCollection=>[:fonts],
  Watir::ImageCollection=>[:imgs, :images],
  Watir::FrameCollection=>[:frames],
  Watir::HiddenCollection=>[:hiddens],
  Watir::Image=>[:img, :image],
  Watir::AnchorCollection=>[:as, :links],
  Watir::Radio=>[:radio],
  Watir::Track=>[:track],
  Watir::RadioCollection=>[:radios],
  Watir::Select=>[:select, :select_list],
  Watir::SelectCollection=>[:selects, :select_lists],
  Watir::Pattern=>[:pattern],
  Watir::TextField=>[:text_field],
  Watir::TextFieldCollection=>[:text_fields],
  Watir::Use=>[:use],
  Watir::TableCaption=>[:caption],
  Watir::FieldSet=>[:fieldset, :field_set],
  Watir::FieldSetCollection=>[:fieldsets, :field_sets],
  Watir::Input=>[:input],
  Watir::Output=>[:output],
  Watir::Area=>[:area],
  Watir::Audio=>[:audio],
  Watir::AudioCollection=>[:audios],
  Watir::BaseCollection=>[:bases],
  Watir::Quote=>[:blockquote, :q],
  Watir::QuoteCollection=>[:blockquotes, :qs],
  Watir::BodyCollection=>[:bodys],
  Watir::BR=>[:br],
  Watir::BRCollection=>[:brs],
  Watir::ButtonCollection=>[:buttons],
  Watir::Canvas=>[:canvas],
  Watir::CanvasCollection=>[:canvases],
  Watir::TableCaptionCollection=>[:captions],
  Watir::TableCol=>[:colgroup, :col],
  Watir::TableColCollection=>[:colgroups, :cols],
  Watir::DataCollection=>[:datas],
  Watir::DataList=>[:datalist],
  Watir::DataListCollection=>[:datalists],
  Watir::Mod=>[:del, :ins],
  Watir::ModCollection=>[:dels, :inses],
  Watir::DetailsCollection=>[:detailses],
  Watir::DivCollection=>[:divs],
  Watir::DList=>[:dl],
  Watir::DListCollection=>[:dls],
  Watir::Embed=>[:embed],
  Watir::EmbedCollection=>[:embeds],
  Watir::FormCollection=>[:forms],
  Watir::FrameSet=>[:frameset],
  Watir::FrameSetCollection=>[:framesets],
  Watir::Heading=>[:h1, :h2, :h4, :h5, :h6, :h3],
  Watir::HeadingCollection=>[:h1s, :h2s, :h3s, :h4s, :h5s, :h6s],
  Watir::Form=>[:form],
  Watir::Head=>[:head],
  Watir::HeadCollection=>[:heads],
  Watir::HRCollection=>[:hrs],
  Watir::HtmlCollection=>[:htmls],
  Watir::HR=>[:hr],
  Watir::IFrame=>[:iframe],
  Watir::InputCollection=>[:inputs],
  Watir::LegendCollection=>[:legends],
  Watir::LICollection=>[:lis],
  Watir::IFrameCollection=>[:iframes],
  Watir::Legend=>[:legend],
  Watir::Meter=>[:meter],
  Watir::Label=>[:label],
  Watir::Div=>[:div],
  Watir::MapCollection=>[:maps],
  Watir::MeterCollection=>[:meters],
  Watir::MetaCollection=>[:metas],
  Watir::Param=>[:param],
  Watir::Data=>[:data],
  Watir::OptGroupCollection=>[:optgroups],
  Watir::OList=>[:ol],
  Watir::OptGroup=>[:optgroup],
  Watir::ParamCollection=>[:params],
  Watir::PreCollection=>[:pres],
  Watir::Object=>[:object],
  Watir::OListCollection=>[:ols],
  Watir::ParagraphCollection=>[:ps],
  Watir::ObjectCollection=>[:objects],
  Watir::Picture=>[:picture],
  Watir::PictureCollection=>[:pictures],
  Watir::Progress=>[:progress],
  Watir::Map=>[:map],
  Watir::OutputCollection=>[:outputs],
  Watir::OptionCollection=>[:options],
  Watir::ScriptCollection=>[:scripts],
  Watir::ProgressCollection=>[:progresses],
  Watir::SpanCollection=>[:spans],
  Watir::Source=>[:source],
  Watir::StyleCollection=>[:styles],
  Watir::Paragraph=>[:p],
  Watir::TableSectionCollection=>[:tbodys, :tfoots, :theads],
  Watir::TableDataCell=>[:td],
  Watir::TableDataCellCollection=>[:tds],
  Watir::Span=>[:span],
  Watir::TableCollection=>[:tables],
  Watir::TableSection=>[:tbody, :tfoot, :thead],
  Watir::Meta=>[:meta],
  Watir::TableHeaderCell=>[:th],
  Watir::TableHeaderCellCollection=>[:ths],
  Watir::Template=>[:template],
  Watir::TextArea=>[:textarea],
  Watir::TemplateCollection=>[:templates],
  Watir::TitleCollection=>[:titles],
  Watir::TextAreaCollection=>[:textareas],
  Watir::TrackCollection=>[:tracks],
  Watir::UList=>[:ul],
  Watir::Table=>[:table],
  Watir::Base=>[:base],
  Watir::TableRowCollection=>[:trs],
  Watir::Line=>[:line],
  Watir::Symbol=>[:symbol],
  Watir::UListCollection=>[:uls],
  Watir::Video=>[:video],
  Watir::VideoCollection=>[:videos],
  Watir::G=>[:g],
  Watir::Frame=>[:frame],
  Watir::SourceCollection=>[:sources],
  Watir::Option=>[:option],
  Watir::PathCollection=>[:paths],
  Watir::TableRow=>[:tr],
  Watir::Path=>[:path],
  Watir::LineCollection=>[:lines],
  Watir::LabelCollection=>[:labels],
  Watir::Time=>[:time],
  Watir::SymbolCollection=>[:symbols],
  Watir::Details=>[:details],
  Watir::Stop=>[:stop],
  Watir::Switch=>[:switch],
  Watir::Hidden=>[:hidden]
  }.freeze


  # Watir DOM methods. This data is used to create class-level element accessors
  # for page objects.
  DOM_METHODS = %i(
    a            br          datalists         elements          forms       hidden   li                             params            rect          source     tbody        tspan
    abbr         brs         datas             ellipse           frame       hiddens  line                           path              rects         sources    tbodys       tspans
    abbrs        bs          date_field        ellipses          frames      hr       linear_gradient                paths             rp            span       td           u
    address      button      date_fields       em                frameset    hrs      linear_gradients  meta         pattern           rps           spans      tds          ul
    addresses    buttons     date_time_field   embed             framesets   htmls    lines             metadata     patterns          rt            ss         template     uls
    area         canvas      date_time_fields  embeds            g           i        link              metadatas    picture           rtc           stop       templates    us
    areas        canvases    dd                ems               gs          iframe   links             metas        pictures          rtcs          stops      text_field   use
    article      caption     dds               extract_selector  h1          iframes  lis               meter        polygon           rts           strong     text_fields  uses
    articles     captions    defs              field_set         h1s         image    main              meters       polygons          rubies        strongs    text_path    var
    as           checkbox    defss             field_sets        h2          images   mains             nav          polyline          ruby          style      text_paths   vars
    aside        checkboxes  del               fieldset          h2s         img      map               navs         polylines         s             styles     textarea     video
    asides       circle      dels              fieldsets         h3          imgs     maps              noscript     pre               samp          sub        textareas    videos
    audio        circles     desc              figcaption        h3s         input    mark              noscripts    pres              samps         subs       tfoot        view
    audios       cite        descs             figcaptions       h4          inputs   marker            object       progress          script        summaries  tfoots       views
    b            cites       details           figure            h4s         ins      markers           objects      progresses        scripts       summary    th           wbr
    base         code        detailses         figures           h5          inses    marks             ol           ps                section       sup        thead        wbrs
    bases        codes       dfn               file_field        h5s         is                         ols          q                 sections      sups       theads
    bdi          col         dfns              file_fields       h6          kbd                        optgroup     qs                select        svg        ths
    bdis         colgroup    div               font              h6s         kbds                       optgroups    radial_gradient   select_list   svgs       time
    bdo          colgroups   divs              fonts                                                    option       radial_gradients  select_lists  switch     times
    bdos         cols        dl                footer                                                   options      radio             selects       switches   titles
    blockquote               dls               footers           head        label                      output       small             symbol        tr
    blockquotes              dt                foreign_object    header      labels                     outputs      radios            smalls        symbols    track
    body         data        dts               foreign_objects   headers     legend                     p            rb                              table      tracks
    bodys        datalist    element           form              heads       legends                    param        rbs                             tables     trs
  ).freeze
end
